'''
Created on Aug 26, 2010

@author: donal
'''
from cocos.sprite import Sprite
from cocos.layer import Layer
import pyglet

import data

class Actor(Sprite):

    def __init__(self):
        pass
    
    def update(self):
        pass

class PlayerActor(Sprite):
    FACING_LEFT = 0
    FACING_RIGHT = 1
    images = dict()
    state = 'walking'
    facing = 0
    
    def __init__(self, state='standing', position=(0,0), facing=0):
        self.state = state
        standing = pyglet.image.load(data.filepath('dude_01.png'))
        self.images['standing'] = standing.texture
        
        jumping = pyglet.image.load(data.filepath('dude_03.png'))
        self.images['jumping'] = jumping.texture 

        walking = (pyglet.image.load(img_filename) for img_filename in [data.filepath('dude_01.png'), data.filepath('dude_02.png'), data.filepath('dude_03.png')])
        self.images['walking'] = pyglet.image.Animation.from_image_sequence(walking, 0.1)
        if (facing == self.FACING_LEFT):
            self.facing = True
        else:
            self.facing = False
        super(PlayerActor, self).__init__(self.images[self.state].get_transform(flip_x=self.facing), position)
        self.image_anchor_y = 0
        
    def update(self):
        x, y = self.parent.manager.pixel_from_screen(self.position)
        self.parent.manager.set_focus(x, y)

        if (self.state in self.images):
            self.sprite = Sprite(self.images[self.state])

    def changeState(self, state='standing'):
        print 'changeState: ', state
        if (state in self.images):
            self.state = state
        else:
            self.state = 'standing'
        self.image = self.images[self.state].get_transform(flip_x=self.facing)
            
        
