'''
Created on Aug 26, 2010

@author: donal
'''

from cocos.menu import *
from cocos.director import *
from cocos.sprite import Sprite

from cocos.tiles import *

from cocos.layer import ScrollableLayer, ScrollingManager

from cocos.actions import *

import pyglet
from pyglet.resource import *
from pyglet.window import key

from vector import distv

from FuzzyFroggy.Actors import *
from FuzzyFroggy.ActorActions import *
import data

class MouseCursorRect():
    position = (0,0)
    width = 0
    height = 0
    def __init__(self, position=(0,0), width=0, height=0):
        self.position = position
        self.width = width
        self.height = height

class PlayerLayer(ScrollableLayer):
    is_event_handler = True
    action_menu = None
    action_queue = [Delay(1), PlayerMove((50,40), 3)]
    #way_points = [(50, 40), (50, 250), (700, 250)];
    player = None
    stage_objects = []
    manager = None
    
    action_menu = None;
    
    def __init__(self):
        super(PlayerLayer, self).__init__()#100, 0, 50, 50, width=1600, height=1200)
        self.set_view(0, 0, 800, 480)
        
        win_width, win_height = director.get_window_size()
        p_x = 10
        self.platforms = []
        
        while (p_x < win_width):
            print win_width, p_x
            tmp = Sprite(pyglet.image.load(data.filepath('platform_01.png')))
            tmp.position = (p_x, 5)
            tmp.image_anchor_y = 0
            self.platforms.append(tmp)
            self.add(tmp, z=0)
            p_x += (tmp.width - 30)
        
#        r = load('tiles.xml')
        self.manager = ScrollingManager()
        self.manager.add(self)
            
        obstacle = Sprite(pyglet.image.load(data.filepath('box_01.png')))
        obstacle.position = (380, 30)
        obstacle.image_anchor_y = 0
        self.stage_objects.append(obstacle)
        self.add(obstacle, z=1)
        
        self.player = PlayerActor('standing', (750, 30))

        self.add(self.player, z=3)
        self.act()
        
    def act(self):
        if len(self.action_queue) > 0:
            target_act = self.action_queue.pop(0)
        else:
            target_act = PlayerDelay(1)
        print 'act', target_act
        self.player.do(target_act + CallFunc(self.act))
        
    def on_key_press(self, k , m ):
        if k == key.SPACE:
            self.way_points = []
        
    def on_mouse_press(self, x, y, btn, mod):
        mouse = MouseCursorRect((x,y), 20, 20)
        
        for obj in self.stage_objects:
            if (sprite_intersect(mouse, obj)):
                if (self.action_menu == None):
                    self.action_menu = Menu()
                    self.action_menu.menu_valign = CENTER
                    self.action_menu.menu_halign = CENTER
                    self.action_menu.items = []
                    action1 = PlayerJump((-150, 0), 110, 1, 2)
                    self.action_menu.items.append(MenuItem('Jump', self.addAction, action1))
                    
                    self.action_menu.create_menu(self.action_menu.items, zoom_in(), zoom_out())
                    self.action_menu.on_quit = self.close_action_menu
                    self.add(self.action_menu)
    
    def addAction(self, act):
        print 'addAction ', self.action_queue
        self.action_queue.append(act)
        #self.player.do(act)
        #self.remove(self.action_menu)
        self.close_action_menu()
        
    def close_action_menu(self):
        print 'close action menu'
        self.remove(self.action_menu)
        self.action_menu = None
